// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: matrix.proto

#ifndef PROTOBUF_matrix_2eproto__INCLUDED
#define PROTOBUF_matrix_2eproto__INCLUDED

#include <string>

#include <google/protobuf/stubs/common.h>

#if GOOGLE_PROTOBUF_VERSION < 2005000
#error This file was generated by a newer version of protoc which is
#error incompatible with your Protocol Buffer headers.  Please update
#error your headers.
#endif
#if 2005000 < GOOGLE_PROTOBUF_MIN_PROTOC_VERSION
#error This file was generated by an older version of protoc which is
#error incompatible with your Protocol Buffer headers.  Please
#error regenerate this file with a newer version of protoc.
#endif

#include <google/protobuf/generated_message_util.h>
#include <google/protobuf/message.h>
#include <google/protobuf/repeated_field.h>
#include <google/protobuf/extension_set.h>
#include <google/protobuf/generated_enum_reflection.h>
#include <google/protobuf/unknown_field_set.h>
// @@protoc_insertion_point(includes)

// Internal implementation detail -- do not call these.
void  protobuf_AddDesc_matrix_2eproto();
void protobuf_AssignDesc_matrix_2eproto();
void protobuf_ShutdownFile_matrix_2eproto();

class double_t;
class int_t;
class bool_t;
class MatrixBuffer;

enum MatrixBuffer_Class {
  MatrixBuffer_Class_FULL = 1,
  MatrixBuffer_Class_SYMM = 2
};
bool MatrixBuffer_Class_IsValid(int value);
const MatrixBuffer_Class MatrixBuffer_Class_Class_MIN = MatrixBuffer_Class_FULL;
const MatrixBuffer_Class MatrixBuffer_Class_Class_MAX = MatrixBuffer_Class_SYMM;
const int MatrixBuffer_Class_Class_ARRAYSIZE = MatrixBuffer_Class_Class_MAX + 1;

const ::google::protobuf::EnumDescriptor* MatrixBuffer_Class_descriptor();
inline const ::std::string& MatrixBuffer_Class_Name(MatrixBuffer_Class value) {
  return ::google::protobuf::internal::NameOfEnum(
    MatrixBuffer_Class_descriptor(), value);
}
inline bool MatrixBuffer_Class_Parse(
    const ::std::string& name, MatrixBuffer_Class* value) {
  return ::google::protobuf::internal::ParseNamedEnum<MatrixBuffer_Class>(
    MatrixBuffer_Class_descriptor(), name, value);
}
enum MatrixBuffer_Type {
  MatrixBuffer_Type_FLOAT = 1,
  MatrixBuffer_Type_INT = 2,
  MatrixBuffer_Type_BOOL = 3
};
bool MatrixBuffer_Type_IsValid(int value);
const MatrixBuffer_Type MatrixBuffer_Type_Type_MIN = MatrixBuffer_Type_FLOAT;
const MatrixBuffer_Type MatrixBuffer_Type_Type_MAX = MatrixBuffer_Type_BOOL;
const int MatrixBuffer_Type_Type_ARRAYSIZE = MatrixBuffer_Type_Type_MAX + 1;

const ::google::protobuf::EnumDescriptor* MatrixBuffer_Type_descriptor();
inline const ::std::string& MatrixBuffer_Type_Name(MatrixBuffer_Type value) {
  return ::google::protobuf::internal::NameOfEnum(
    MatrixBuffer_Type_descriptor(), value);
}
inline bool MatrixBuffer_Type_Parse(
    const ::std::string& name, MatrixBuffer_Type* value) {
  return ::google::protobuf::internal::ParseNamedEnum<MatrixBuffer_Type>(
    MatrixBuffer_Type_descriptor(), name, value);
}
// ===================================================================

class double_t : public ::google::protobuf::Message {
 public:
  double_t();
  virtual ~double_t();

  double_t(const double_t& from);

  inline double_t& operator=(const double_t& from) {
    CopyFrom(from);
    return *this;
  }

  inline const ::google::protobuf::UnknownFieldSet& unknown_fields() const {
    return _unknown_fields_;
  }

  inline ::google::protobuf::UnknownFieldSet* mutable_unknown_fields() {
    return &_unknown_fields_;
  }

  static const ::google::protobuf::Descriptor* descriptor();
  static const double_t& default_instance();

  void Swap(double_t* other);

  // implements Message ----------------------------------------------

  double_t* New() const;
  void CopyFrom(const ::google::protobuf::Message& from);
  void MergeFrom(const ::google::protobuf::Message& from);
  void CopyFrom(const double_t& from);
  void MergeFrom(const double_t& from);
  void Clear();
  bool IsInitialized() const;

  int ByteSize() const;
  bool MergePartialFromCodedStream(
      ::google::protobuf::io::CodedInputStream* input);
  void SerializeWithCachedSizes(
      ::google::protobuf::io::CodedOutputStream* output) const;
  ::google::protobuf::uint8* SerializeWithCachedSizesToArray(::google::protobuf::uint8* output) const;
  int GetCachedSize() const { return _cached_size_; }
  private:
  void SharedCtor();
  void SharedDtor();
  void SetCachedSize(int size) const;
  public:

  ::google::protobuf::Metadata GetMetadata() const;

  // nested types ----------------------------------------------------

  // accessors -------------------------------------------------------

  // repeated double data = 1 [packed = true];
  inline int data_size() const;
  inline void clear_data();
  static const int kDataFieldNumber = 1;
  inline double data(int index) const;
  inline void set_data(int index, double value);
  inline void add_data(double value);
  inline const ::google::protobuf::RepeatedField< double >&
      data() const;
  inline ::google::protobuf::RepeatedField< double >*
      mutable_data();

  // @@protoc_insertion_point(class_scope:double_t)
 private:

  ::google::protobuf::UnknownFieldSet _unknown_fields_;

  ::google::protobuf::RepeatedField< double > data_;
  mutable int _data_cached_byte_size_;

  mutable int _cached_size_;
  ::google::protobuf::uint32 _has_bits_[(1 + 31) / 32];

  friend void  protobuf_AddDesc_matrix_2eproto();
  friend void protobuf_AssignDesc_matrix_2eproto();
  friend void protobuf_ShutdownFile_matrix_2eproto();

  void InitAsDefaultInstance();
  static double_t* default_instance_;
};
// -------------------------------------------------------------------

class int_t : public ::google::protobuf::Message {
 public:
  int_t();
  virtual ~int_t();

  int_t(const int_t& from);

  inline int_t& operator=(const int_t& from) {
    CopyFrom(from);
    return *this;
  }

  inline const ::google::protobuf::UnknownFieldSet& unknown_fields() const {
    return _unknown_fields_;
  }

  inline ::google::protobuf::UnknownFieldSet* mutable_unknown_fields() {
    return &_unknown_fields_;
  }

  static const ::google::protobuf::Descriptor* descriptor();
  static const int_t& default_instance();

  void Swap(int_t* other);

  // implements Message ----------------------------------------------

  int_t* New() const;
  void CopyFrom(const ::google::protobuf::Message& from);
  void MergeFrom(const ::google::protobuf::Message& from);
  void CopyFrom(const int_t& from);
  void MergeFrom(const int_t& from);
  void Clear();
  bool IsInitialized() const;

  int ByteSize() const;
  bool MergePartialFromCodedStream(
      ::google::protobuf::io::CodedInputStream* input);
  void SerializeWithCachedSizes(
      ::google::protobuf::io::CodedOutputStream* output) const;
  ::google::protobuf::uint8* SerializeWithCachedSizesToArray(::google::protobuf::uint8* output) const;
  int GetCachedSize() const { return _cached_size_; }
  private:
  void SharedCtor();
  void SharedDtor();
  void SetCachedSize(int size) const;
  public:

  ::google::protobuf::Metadata GetMetadata() const;

  // nested types ----------------------------------------------------

  // accessors -------------------------------------------------------

  // repeated int32 data = 1 [packed = true];
  inline int data_size() const;
  inline void clear_data();
  static const int kDataFieldNumber = 1;
  inline ::google::protobuf::int32 data(int index) const;
  inline void set_data(int index, ::google::protobuf::int32 value);
  inline void add_data(::google::protobuf::int32 value);
  inline const ::google::protobuf::RepeatedField< ::google::protobuf::int32 >&
      data() const;
  inline ::google::protobuf::RepeatedField< ::google::protobuf::int32 >*
      mutable_data();

  // @@protoc_insertion_point(class_scope:int_t)
 private:

  ::google::protobuf::UnknownFieldSet _unknown_fields_;

  ::google::protobuf::RepeatedField< ::google::protobuf::int32 > data_;
  mutable int _data_cached_byte_size_;

  mutable int _cached_size_;
  ::google::protobuf::uint32 _has_bits_[(1 + 31) / 32];

  friend void  protobuf_AddDesc_matrix_2eproto();
  friend void protobuf_AssignDesc_matrix_2eproto();
  friend void protobuf_ShutdownFile_matrix_2eproto();

  void InitAsDefaultInstance();
  static int_t* default_instance_;
};
// -------------------------------------------------------------------

class bool_t : public ::google::protobuf::Message {
 public:
  bool_t();
  virtual ~bool_t();

  bool_t(const bool_t& from);

  inline bool_t& operator=(const bool_t& from) {
    CopyFrom(from);
    return *this;
  }

  inline const ::google::protobuf::UnknownFieldSet& unknown_fields() const {
    return _unknown_fields_;
  }

  inline ::google::protobuf::UnknownFieldSet* mutable_unknown_fields() {
    return &_unknown_fields_;
  }

  static const ::google::protobuf::Descriptor* descriptor();
  static const bool_t& default_instance();

  void Swap(bool_t* other);

  // implements Message ----------------------------------------------

  bool_t* New() const;
  void CopyFrom(const ::google::protobuf::Message& from);
  void MergeFrom(const ::google::protobuf::Message& from);
  void CopyFrom(const bool_t& from);
  void MergeFrom(const bool_t& from);
  void Clear();
  bool IsInitialized() const;

  int ByteSize() const;
  bool MergePartialFromCodedStream(
      ::google::protobuf::io::CodedInputStream* input);
  void SerializeWithCachedSizes(
      ::google::protobuf::io::CodedOutputStream* output) const;
  ::google::protobuf::uint8* SerializeWithCachedSizesToArray(::google::protobuf::uint8* output) const;
  int GetCachedSize() const { return _cached_size_; }
  private:
  void SharedCtor();
  void SharedDtor();
  void SetCachedSize(int size) const;
  public:

  ::google::protobuf::Metadata GetMetadata() const;

  // nested types ----------------------------------------------------

  // accessors -------------------------------------------------------

  // repeated bool data = 1 [packed = true];
  inline int data_size() const;
  inline void clear_data();
  static const int kDataFieldNumber = 1;
  inline bool data(int index) const;
  inline void set_data(int index, bool value);
  inline void add_data(bool value);
  inline const ::google::protobuf::RepeatedField< bool >&
      data() const;
  inline ::google::protobuf::RepeatedField< bool >*
      mutable_data();

  // @@protoc_insertion_point(class_scope:bool_t)
 private:

  ::google::protobuf::UnknownFieldSet _unknown_fields_;

  ::google::protobuf::RepeatedField< bool > data_;
  mutable int _data_cached_byte_size_;

  mutable int _cached_size_;
  ::google::protobuf::uint32 _has_bits_[(1 + 31) / 32];

  friend void  protobuf_AddDesc_matrix_2eproto();
  friend void protobuf_AssignDesc_matrix_2eproto();
  friend void protobuf_ShutdownFile_matrix_2eproto();

  void InitAsDefaultInstance();
  static bool_t* default_instance_;
};
// -------------------------------------------------------------------

class MatrixBuffer : public ::google::protobuf::Message {
 public:
  MatrixBuffer();
  virtual ~MatrixBuffer();

  MatrixBuffer(const MatrixBuffer& from);

  inline MatrixBuffer& operator=(const MatrixBuffer& from) {
    CopyFrom(from);
    return *this;
  }

  inline const ::google::protobuf::UnknownFieldSet& unknown_fields() const {
    return _unknown_fields_;
  }

  inline ::google::protobuf::UnknownFieldSet* mutable_unknown_fields() {
    return &_unknown_fields_;
  }

  static const ::google::protobuf::Descriptor* descriptor();
  static const MatrixBuffer& default_instance();

  void Swap(MatrixBuffer* other);

  // implements Message ----------------------------------------------

  MatrixBuffer* New() const;
  void CopyFrom(const ::google::protobuf::Message& from);
  void MergeFrom(const ::google::protobuf::Message& from);
  void CopyFrom(const MatrixBuffer& from);
  void MergeFrom(const MatrixBuffer& from);
  void Clear();
  bool IsInitialized() const;

  int ByteSize() const;
  bool MergePartialFromCodedStream(
      ::google::protobuf::io::CodedInputStream* input);
  void SerializeWithCachedSizes(
      ::google::protobuf::io::CodedOutputStream* output) const;
  ::google::protobuf::uint8* SerializeWithCachedSizesToArray(::google::protobuf::uint8* output) const;
  int GetCachedSize() const { return _cached_size_; }
  private:
  void SharedCtor();
  void SharedDtor();
  void SetCachedSize(int size) const;
  public:

  ::google::protobuf::Metadata GetMetadata() const;

  // nested types ----------------------------------------------------

  typedef MatrixBuffer_Class Class;
  static const Class FULL = MatrixBuffer_Class_FULL;
  static const Class SYMM = MatrixBuffer_Class_SYMM;
  static inline bool Class_IsValid(int value) {
    return MatrixBuffer_Class_IsValid(value);
  }
  static const Class Class_MIN =
    MatrixBuffer_Class_Class_MIN;
  static const Class Class_MAX =
    MatrixBuffer_Class_Class_MAX;
  static const int Class_ARRAYSIZE =
    MatrixBuffer_Class_Class_ARRAYSIZE;
  static inline const ::google::protobuf::EnumDescriptor*
  Class_descriptor() {
    return MatrixBuffer_Class_descriptor();
  }
  static inline const ::std::string& Class_Name(Class value) {
    return MatrixBuffer_Class_Name(value);
  }
  static inline bool Class_Parse(const ::std::string& name,
      Class* value) {
    return MatrixBuffer_Class_Parse(name, value);
  }

  typedef MatrixBuffer_Type Type;
  static const Type FLOAT = MatrixBuffer_Type_FLOAT;
  static const Type INT = MatrixBuffer_Type_INT;
  static const Type BOOL = MatrixBuffer_Type_BOOL;
  static inline bool Type_IsValid(int value) {
    return MatrixBuffer_Type_IsValid(value);
  }
  static const Type Type_MIN =
    MatrixBuffer_Type_Type_MIN;
  static const Type Type_MAX =
    MatrixBuffer_Type_Type_MAX;
  static const int Type_ARRAYSIZE =
    MatrixBuffer_Type_Type_ARRAYSIZE;
  static inline const ::google::protobuf::EnumDescriptor*
  Type_descriptor() {
    return MatrixBuffer_Type_descriptor();
  }
  static inline const ::std::string& Type_Name(Type value) {
    return MatrixBuffer_Type_Name(value);
  }
  static inline bool Type_Parse(const ::std::string& name,
      Type* value) {
    return MatrixBuffer_Type_Parse(name, value);
  }

  // accessors -------------------------------------------------------

  // required string name = 1;
  inline bool has_name() const;
  inline void clear_name();
  static const int kNameFieldNumber = 1;
  inline const ::std::string& name() const;
  inline void set_name(const ::std::string& value);
  inline void set_name(const char* value);
  inline void set_name(const char* value, size_t size);
  inline ::std::string* mutable_name();
  inline ::std::string* release_name();
  inline void set_allocated_name(::std::string* name);

  // required .MatrixBuffer.Class class = 2;
  inline bool has_class_() const;
  inline void clear_class_();
  static const int kClassFieldNumber = 2;
  inline ::MatrixBuffer_Class class_() const;
  inline void set_class_(::MatrixBuffer_Class value);

  // required .MatrixBuffer.Type type = 3;
  inline bool has_type() const;
  inline void clear_type();
  static const int kTypeFieldNumber = 3;
  inline ::MatrixBuffer_Type type() const;
  inline void set_type(::MatrixBuffer_Type value);

  // required int32 nrow = 4;
  inline bool has_nrow() const;
  inline void clear_nrow();
  static const int kNrowFieldNumber = 4;
  inline ::google::protobuf::int32 nrow() const;
  inline void set_nrow(::google::protobuf::int32 value);

  // required int32 ncol = 5;
  inline bool has_ncol() const;
  inline void clear_ncol();
  static const int kNcolFieldNumber = 5;
  inline ::google::protobuf::int32 ncol() const;
  inline void set_ncol(::google::protobuf::int32 value);

  // repeated .double_t d_double = 6;
  inline int d_double_size() const;
  inline void clear_d_double();
  static const int kDDoubleFieldNumber = 6;
  inline const ::double_t& d_double(int index) const;
  inline ::double_t* mutable_d_double(int index);
  inline ::double_t* add_d_double();
  inline const ::google::protobuf::RepeatedPtrField< ::double_t >&
      d_double() const;
  inline ::google::protobuf::RepeatedPtrField< ::double_t >*
      mutable_d_double();

  // repeated .int_t d_int = 7;
  inline int d_int_size() const;
  inline void clear_d_int();
  static const int kDIntFieldNumber = 7;
  inline const ::int_t& d_int(int index) const;
  inline ::int_t* mutable_d_int(int index);
  inline ::int_t* add_d_int();
  inline const ::google::protobuf::RepeatedPtrField< ::int_t >&
      d_int() const;
  inline ::google::protobuf::RepeatedPtrField< ::int_t >*
      mutable_d_int();

  // repeated .bool_t d_bool = 8;
  inline int d_bool_size() const;
  inline void clear_d_bool();
  static const int kDBoolFieldNumber = 8;
  inline const ::bool_t& d_bool(int index) const;
  inline ::bool_t* mutable_d_bool(int index);
  inline ::bool_t* add_d_bool();
  inline const ::google::protobuf::RepeatedPtrField< ::bool_t >&
      d_bool() const;
  inline ::google::protobuf::RepeatedPtrField< ::bool_t >*
      mutable_d_bool();

  // @@protoc_insertion_point(class_scope:MatrixBuffer)
 private:
  inline void set_has_name();
  inline void clear_has_name();
  inline void set_has_class_();
  inline void clear_has_class_();
  inline void set_has_type();
  inline void clear_has_type();
  inline void set_has_nrow();
  inline void clear_has_nrow();
  inline void set_has_ncol();
  inline void clear_has_ncol();

  ::google::protobuf::UnknownFieldSet _unknown_fields_;

  ::std::string* name_;
  int class__;
  int type_;
  ::google::protobuf::int32 nrow_;
  ::google::protobuf::int32 ncol_;
  ::google::protobuf::RepeatedPtrField< ::double_t > d_double_;
  ::google::protobuf::RepeatedPtrField< ::int_t > d_int_;
  ::google::protobuf::RepeatedPtrField< ::bool_t > d_bool_;

  mutable int _cached_size_;
  ::google::protobuf::uint32 _has_bits_[(8 + 31) / 32];

  friend void  protobuf_AddDesc_matrix_2eproto();
  friend void protobuf_AssignDesc_matrix_2eproto();
  friend void protobuf_ShutdownFile_matrix_2eproto();

  void InitAsDefaultInstance();
  static MatrixBuffer* default_instance_;
};
// ===================================================================


// ===================================================================

// double_t

// repeated double data = 1 [packed = true];
inline int double_t::data_size() const {
  return data_.size();
}
inline void double_t::clear_data() {
  data_.Clear();
}
inline double double_t::data(int index) const {
  return data_.Get(index);
}
inline void double_t::set_data(int index, double value) {
  data_.Set(index, value);
}
inline void double_t::add_data(double value) {
  data_.Add(value);
}
inline const ::google::protobuf::RepeatedField< double >&
double_t::data() const {
  return data_;
}
inline ::google::protobuf::RepeatedField< double >*
double_t::mutable_data() {
  return &data_;
}

// -------------------------------------------------------------------

// int_t

// repeated int32 data = 1 [packed = true];
inline int int_t::data_size() const {
  return data_.size();
}
inline void int_t::clear_data() {
  data_.Clear();
}
inline ::google::protobuf::int32 int_t::data(int index) const {
  return data_.Get(index);
}
inline void int_t::set_data(int index, ::google::protobuf::int32 value) {
  data_.Set(index, value);
}
inline void int_t::add_data(::google::protobuf::int32 value) {
  data_.Add(value);
}
inline const ::google::protobuf::RepeatedField< ::google::protobuf::int32 >&
int_t::data() const {
  return data_;
}
inline ::google::protobuf::RepeatedField< ::google::protobuf::int32 >*
int_t::mutable_data() {
  return &data_;
}

// -------------------------------------------------------------------

// bool_t

// repeated bool data = 1 [packed = true];
inline int bool_t::data_size() const {
  return data_.size();
}
inline void bool_t::clear_data() {
  data_.Clear();
}
inline bool bool_t::data(int index) const {
  return data_.Get(index);
}
inline void bool_t::set_data(int index, bool value) {
  data_.Set(index, value);
}
inline void bool_t::add_data(bool value) {
  data_.Add(value);
}
inline const ::google::protobuf::RepeatedField< bool >&
bool_t::data() const {
  return data_;
}
inline ::google::protobuf::RepeatedField< bool >*
bool_t::mutable_data() {
  return &data_;
}

// -------------------------------------------------------------------

// MatrixBuffer

// required string name = 1;
inline bool MatrixBuffer::has_name() const {
  return (_has_bits_[0] & 0x00000001u) != 0;
}
inline void MatrixBuffer::set_has_name() {
  _has_bits_[0] |= 0x00000001u;
}
inline void MatrixBuffer::clear_has_name() {
  _has_bits_[0] &= ~0x00000001u;
}
inline void MatrixBuffer::clear_name() {
  if (name_ != &::google::protobuf::internal::kEmptyString) {
    name_->clear();
  }
  clear_has_name();
}
inline const ::std::string& MatrixBuffer::name() const {
  return *name_;
}
inline void MatrixBuffer::set_name(const ::std::string& value) {
  set_has_name();
  if (name_ == &::google::protobuf::internal::kEmptyString) {
    name_ = new ::std::string;
  }
  name_->assign(value);
}
inline void MatrixBuffer::set_name(const char* value) {
  set_has_name();
  if (name_ == &::google::protobuf::internal::kEmptyString) {
    name_ = new ::std::string;
  }
  name_->assign(value);
}
inline void MatrixBuffer::set_name(const char* value, size_t size) {
  set_has_name();
  if (name_ == &::google::protobuf::internal::kEmptyString) {
    name_ = new ::std::string;
  }
  name_->assign(reinterpret_cast<const char*>(value), size);
}
inline ::std::string* MatrixBuffer::mutable_name() {
  set_has_name();
  if (name_ == &::google::protobuf::internal::kEmptyString) {
    name_ = new ::std::string;
  }
  return name_;
}
inline ::std::string* MatrixBuffer::release_name() {
  clear_has_name();
  if (name_ == &::google::protobuf::internal::kEmptyString) {
    return NULL;
  } else {
    ::std::string* temp = name_;
    name_ = const_cast< ::std::string*>(&::google::protobuf::internal::kEmptyString);
    return temp;
  }
}
inline void MatrixBuffer::set_allocated_name(::std::string* name) {
  if (name_ != &::google::protobuf::internal::kEmptyString) {
    delete name_;
  }
  if (name) {
    set_has_name();
    name_ = name;
  } else {
    clear_has_name();
    name_ = const_cast< ::std::string*>(&::google::protobuf::internal::kEmptyString);
  }
}

// required .MatrixBuffer.Class class = 2;
inline bool MatrixBuffer::has_class_() const {
  return (_has_bits_[0] & 0x00000002u) != 0;
}
inline void MatrixBuffer::set_has_class_() {
  _has_bits_[0] |= 0x00000002u;
}
inline void MatrixBuffer::clear_has_class_() {
  _has_bits_[0] &= ~0x00000002u;
}
inline void MatrixBuffer::clear_class_() {
  class__ = 1;
  clear_has_class_();
}
inline ::MatrixBuffer_Class MatrixBuffer::class_() const {
  return static_cast< ::MatrixBuffer_Class >(class__);
}
inline void MatrixBuffer::set_class_(::MatrixBuffer_Class value) {
  assert(::MatrixBuffer_Class_IsValid(value));
  set_has_class_();
  class__ = value;
}

// required .MatrixBuffer.Type type = 3;
inline bool MatrixBuffer::has_type() const {
  return (_has_bits_[0] & 0x00000004u) != 0;
}
inline void MatrixBuffer::set_has_type() {
  _has_bits_[0] |= 0x00000004u;
}
inline void MatrixBuffer::clear_has_type() {
  _has_bits_[0] &= ~0x00000004u;
}
inline void MatrixBuffer::clear_type() {
  type_ = 1;
  clear_has_type();
}
inline ::MatrixBuffer_Type MatrixBuffer::type() const {
  return static_cast< ::MatrixBuffer_Type >(type_);
}
inline void MatrixBuffer::set_type(::MatrixBuffer_Type value) {
  assert(::MatrixBuffer_Type_IsValid(value));
  set_has_type();
  type_ = value;
}

// required int32 nrow = 4;
inline bool MatrixBuffer::has_nrow() const {
  return (_has_bits_[0] & 0x00000008u) != 0;
}
inline void MatrixBuffer::set_has_nrow() {
  _has_bits_[0] |= 0x00000008u;
}
inline void MatrixBuffer::clear_has_nrow() {
  _has_bits_[0] &= ~0x00000008u;
}
inline void MatrixBuffer::clear_nrow() {
  nrow_ = 0;
  clear_has_nrow();
}
inline ::google::protobuf::int32 MatrixBuffer::nrow() const {
  return nrow_;
}
inline void MatrixBuffer::set_nrow(::google::protobuf::int32 value) {
  set_has_nrow();
  nrow_ = value;
}

// required int32 ncol = 5;
inline bool MatrixBuffer::has_ncol() const {
  return (_has_bits_[0] & 0x00000010u) != 0;
}
inline void MatrixBuffer::set_has_ncol() {
  _has_bits_[0] |= 0x00000010u;
}
inline void MatrixBuffer::clear_has_ncol() {
  _has_bits_[0] &= ~0x00000010u;
}
inline void MatrixBuffer::clear_ncol() {
  ncol_ = 0;
  clear_has_ncol();
}
inline ::google::protobuf::int32 MatrixBuffer::ncol() const {
  return ncol_;
}
inline void MatrixBuffer::set_ncol(::google::protobuf::int32 value) {
  set_has_ncol();
  ncol_ = value;
}

// repeated .double_t d_double = 6;
inline int MatrixBuffer::d_double_size() const {
  return d_double_.size();
}
inline void MatrixBuffer::clear_d_double() {
  d_double_.Clear();
}
inline const ::double_t& MatrixBuffer::d_double(int index) const {
  return d_double_.Get(index);
}
inline ::double_t* MatrixBuffer::mutable_d_double(int index) {
  return d_double_.Mutable(index);
}
inline ::double_t* MatrixBuffer::add_d_double() {
  return d_double_.Add();
}
inline const ::google::protobuf::RepeatedPtrField< ::double_t >&
MatrixBuffer::d_double() const {
  return d_double_;
}
inline ::google::protobuf::RepeatedPtrField< ::double_t >*
MatrixBuffer::mutable_d_double() {
  return &d_double_;
}

// repeated .int_t d_int = 7;
inline int MatrixBuffer::d_int_size() const {
  return d_int_.size();
}
inline void MatrixBuffer::clear_d_int() {
  d_int_.Clear();
}
inline const ::int_t& MatrixBuffer::d_int(int index) const {
  return d_int_.Get(index);
}
inline ::int_t* MatrixBuffer::mutable_d_int(int index) {
  return d_int_.Mutable(index);
}
inline ::int_t* MatrixBuffer::add_d_int() {
  return d_int_.Add();
}
inline const ::google::protobuf::RepeatedPtrField< ::int_t >&
MatrixBuffer::d_int() const {
  return d_int_;
}
inline ::google::protobuf::RepeatedPtrField< ::int_t >*
MatrixBuffer::mutable_d_int() {
  return &d_int_;
}

// repeated .bool_t d_bool = 8;
inline int MatrixBuffer::d_bool_size() const {
  return d_bool_.size();
}
inline void MatrixBuffer::clear_d_bool() {
  d_bool_.Clear();
}
inline const ::bool_t& MatrixBuffer::d_bool(int index) const {
  return d_bool_.Get(index);
}
inline ::bool_t* MatrixBuffer::mutable_d_bool(int index) {
  return d_bool_.Mutable(index);
}
inline ::bool_t* MatrixBuffer::add_d_bool() {
  return d_bool_.Add();
}
inline const ::google::protobuf::RepeatedPtrField< ::bool_t >&
MatrixBuffer::d_bool() const {
  return d_bool_;
}
inline ::google::protobuf::RepeatedPtrField< ::bool_t >*
MatrixBuffer::mutable_d_bool() {
  return &d_bool_;
}


// @@protoc_insertion_point(namespace_scope)

#ifndef SWIG
namespace google {
namespace protobuf {

template <>
inline const EnumDescriptor* GetEnumDescriptor< ::MatrixBuffer_Class>() {
  return ::MatrixBuffer_Class_descriptor();
}
template <>
inline const EnumDescriptor* GetEnumDescriptor< ::MatrixBuffer_Type>() {
  return ::MatrixBuffer_Type_descriptor();
}

}  // namespace google
}  // namespace protobuf
#endif  // SWIG

// @@protoc_insertion_point(global_scope)

#endif  // PROTOBUF_matrix_2eproto__INCLUDED
